        PROGRAM MIEGENM
C  ***************************************************************************
C  * PROGRAMA DE CALCULO--------------------- UNIVERSIDAD DE VALLADOLID -----*
C  *                                              (ESPANA)                   *
C  *   CALCULA DIVERSAS MAGNITUDES DEL SCATTERING DE MIE                     *
C  *   This program calculates Mie scattering magnitudes:Mie scattering      *
C   *  factors: 							     *
C  * (Qe,Qs,Qa), Mie intensities i1,i2, asimetry factor g, single scattering *
C  * albedo w0,                                                              *
C  * These magnitudes are drawn and also the log(intensities I(teta), I(fi)  *
C      YES=SI=S  IN SPANISH LANGUAGE                                         *
C                                                                            *
C                 PROPIEDAD DE:     V. E. Cachorro and L.L. Salcedo          *
C                                Dpto de Fisica Aplicada I                   *
C                                Facultad de Ciencias                        *
C                                Universidad de Valladolid (Spain)           *
C                                                                            *
C  ***************************************************************************


        IMPLICIT COMPLEX (C)
        LOGICAL LDQ,LDS
        CHARACTER*30 FILE,ANS
        DIMENSION A(6,1000)
        DATA CY/(0.,1.)/
        DATA PI2/6.283185307179586/
        DATA PI180/1.7452922E-2/
        PI=ACOS(-1.)
C ESTE PROGRAMA ES LA VERSION EN INGLES(EXISTE LA VERSION EQUIVALENTE
C EN CASTELLANO) 
C  DATOS GENERALES:General data
C******************************
        WRITE(6,2)
 2      format(/' IMPUT the name of the output file'/)
       READ(5,567) FILE
 567    FORMAT(A)
        OPEN(1,STATUS='NEW',FILE=FILE)


 123    CONTINUE
C
        WRITE(6,1)
 1      FORMAT(/'  IMPUT THE WAVELENGHT',
     F  /'REAL AND COMPLEX(AS POSITIVE) VALUES OF THE REFRACTION INDEX
     F  ',/'  AND THE IMPUT ERROR YOU WANT(EPSILON=1.E-08)',/)
        READ(5,*) XLAM,AN,AK,EPSI
        AK=ABS(AK)
C
        WRITE(1,5) XLAM,AN,AK,EPSI
 5      FORMAT(/'  IMPUT DATA'
     F  /'  WAVELENGTH..............',F13.6,
     F  /'  REFRACTION INDEX..........',F13.6,' + i ',F13.6,
     F  /'  ERROR TOLERADO (EPSILON).............',E13.6/)
C
C  OPCIONES
C***************
C       CALCULATION AND PLOT OF THE COEFICIENTS Q FOR A RADIUS RANGE
C*********************************************************************
        WRITE(6,6)
 6      FORMAT('  ? DO YOU WANT TO CALCULE THE COEFICIENT Q ? (S/N) ',$)
        READ(5,567) ANS
 7      FORMAT(A)
        IF(ANS.EQ.'S') THEN
C
        WRITE(1,16)
 16     FORMAT('CALCULATION OF THE COEFICIENTS SCATTERING,ABSORTION',
     F  /'  AND EXTINTION, ALBEDO AND ASSIMETRY FACTOR')
C
	TYPE*,'IF YOU WANT TO WORK WITH RADIUS, SET  1,
	1 ON CONTRARY SET 2 TO WORK WITH THE SIZE PARAMETER X'
	ACCEPT*,NPARAM
	IF(NPARAM .EQ. 2)THEN
	TYPE*,'MINIMUM,MAXIMUM SIZE PARAMETER AND NUMBER OF THEM'
	ACCEPT*,PARMIN,PARMAX,PARNUM
	RDMN=PARMIN*XLAM/PI2
	RDMX=PARMAX*XLAM/PI2
	NUMR=PARNUM
	ELSE
        WRITE(6,4)
 4      FORMAT(/'  IMPUT MINIMUM AND MAXIMUM PARTICLE RADIUS '
     F  /'  AND NUMBER OF THEM (NUMBER OF POINTS RADIUS)'/)
        READ(5,*) RDMN,RDMX,NUMR
	END IF
        IF(NUMR.LT.2) NUMR=2
C
        WRITE(1,31) RDMN,RDMX,NUMR
 31     FORMAT(/'  MINIMUM (LOWER)RADIUS..................',F13.6,
     F  /'  MAXIMUM(UPPER) RADIUS..................',F13.6,
     F  /'  NUMBER OF RADIUS..............',I7/)
C
        WRITE(6,8)
 8      FORMAT('  ? DO YOU WANT TO PLOT THE COEFICIENTS Q ? (S/N) ',$)
        READ(5,567) ANS
        LDQ=ANS.EQ.'S'
C

        IF(LDQ) THEN
	TYPE*,'OPTION TO THE NUMBER OF FIGURES, 1 TO 5 AS MAXIMUM
	1 IMPUT TWO NUMBER FROM 1 TO 5: EXAMPLE (1,5)'
	ACCEPT*,IOP1,IOP2
C
        WRITE(1,17)
 17     FORMAT('  DRAWN THE COEFICIENTS Q EN "QMIE.VEC"')
C
        IF(NUMR.GT.1000) WRITE(1,30)
        IF(NUMR.GT.1000) WRITE(6,30)
 30     FORMAT(/'  REDUCE THE NUMBER OF RADIUS TO  1000'/)
        IF(NUMR.GT.1000) NUMR=1000
        NUMW=NUMR
        IF(NUMR.GT.100) WRITE(6,34)
 34     FORMAT('  ? HOW MANY POINTS DO YOU WANT TO WRITE IN THE OUPUT FILE',
     F  /'   ? ',$)
        IF(NUMR.GT.100) READ(5,*) NUMW
        IF(NUMW.EQ.0) NUMW=1
        IF(NUMW.GT.NUMR) NUMW=NUMR
        NSR=NUMR/NUMW
C
        END IF
C
        WRITE(1,35)
 35     FORMAT(1H1/'  RADIUS, COEF. SCATT., COEF. ABS. Y COEF.',
     F  ' OF EXT., SEALB,G(F. ASIM)'/)
        WRITE(6,36)
 36     FORMAT(/'  CALCULATING THE COEFICIENTS'/)
        DO 21 IR=1,NUMR
        RAD=FLOAT(IR-1)/FLOAT(NUMR-1)*(RDMX-RDMN)+RDMN
C
C THE SUBROUTINE 'ABN' CALCULE THE COEFICIENTS A(N) AND B(N) OF THE MIE T.
C---------------------------------------------------------------------------

        CALL ABN(XLAM,RAD,AN,AK,EPSI)

C  THE SUBROUTINE 'QSAE' CALCULE THE COEFICIENTS
C  OF SCATTERING, ABSORCION Y EXTINCION AND THE ALBEDO
C--------------------------------------------------
        CALL QSAE(QS,QA,QE,SEA)
	CALL ASIM(QS,G)
	
C
        IF(LDQ) THEN
          A(1,IR)=RAD
          A(2,IR)=QS
          A(3,IR)=QA
          A(4,IR)=QE
          A(5,IR)=SEA
	  A(6,IR)=G
        END IF
        IF(.NOT.LDQ) WRITE(1,37) RAD,QS,QA,QE,SEA,G
 37     FORMAT(1X,6F13.6)
 21     CONTINUE

        IF(LDQ) WRITE(1,37) ((A(IC,IR),IC=1,6),IR=1,NUMR,NSR)

C  DRAWN THE COEFICIENTS OF SCATTERING, ABSORPTION, EXTINCTION AND ALBEDO
C  WITH THE OPTION (IOP) DE 1, 2, ETC FIGURES
C ----------------------------------------------------------------------
        IF(LDQ) CALL PLQ(IOP1,IOP2,A,RDMN,RDMX,NUMR,XLAM,AN,AK)
C
        END IF

C CALCULATION AND DRAWN OF THE AMPLITUDES FOR A GIVEN RADIUS (part.) 
C AND AN ANGLE RANGE
C ----------------------------------------------------------------------
        WRITE(6,9)
 9      FORMAT('?DO YOU WANT TO CALCULE THE AMPLITUDES S1,S2 ? (S/N) ',
     F  $)
        READ(5,567) ANS
        IF(ANS.EQ.'S') THEN
C
        WRITE(1,18)
 18     FORMAT(/'  CALCULE THE COMPLEX AMPLITUDES S1,S2'/)
        WRITE(6,23)
 23     FORMAT('  IMPUT THE PARTICLE RADIUS  ',$)
        READ(5,*) RAD
	WRITE(1,24)RAD
 24	FORMAT(1X,' PARTICLE RADIUS=',F10.5)
        WRITE(6,25)
 25     FORMAT('  IMPUT THE LOWER POLAR ANGLE (GRADES) ',$)
        READ(5,*) POLMN
        WRITE(6,26)
 26     FORMAT('  IMPUT UPPER POLAR ANGLE ( GRADES) ',$)
        READ(5,*) POLMX
        WRITE(6,27)
 27     FORMAT('  IMPUT THE NUMBER OF ANGLES  ',$)
        READ(5,*) NUMA
        IF(NUMA.LT.2) NUMA=2
C
        WRITE(6,10)
 10     FORMAT('?DO YOU WANT TO PLOT THE INTENSITIES AND THE FASE FUNCTION
	1? (S/N) ',$)
        READ(5,567) ANS
        LDS=ANS.EQ.'S'
C
        IF (LDS) THEN
C
        WRITE(1,40)
 40     FORMAT('  DRAWN THE INTENSITIES IN "SMIE.VEC"'/)
        IF(NUMA.GT.1000) WRITE(1,41)
        IF(NUMA.GT.1000) WRITE(6,41)
 41     FORMAT(/'  REDUCTION OF THE NUMBER OF ANGLES TO 1000'/)
        IF(NUMA.GT.1000) NUMA=1000
        NUMW=NUMA
        IF(NUMA.GT.100) WRITE(6,34)
        IF(NUMA.GT.100) READ(5,*) NUMW
        IF(NUMW.EQ.0) NUMW=1
        IF(NUMW.GT.NUMA) NUMW=NUMA
        NSR=NUMA/NUMW
C
        END IF
C
        WRITE(1,42)
 42     FORMAT(1H1/'ANGLE, AMPLITUDE S1,AMPLITUDE S2, TDELTA, INTENSITIES
	1 I1 Y I2 FOR A GIVEN PARTICLE RADIUS AND FASE FUNCTION',/)
        WRITE(6,43)RAD
 43     FORMAT(1X, 'PARTICLE RADIUS=',F10.5,
     F  /'  CALCULATING  AMPLITUDES  '/)
C
        CALL ABN(XLAM,RAD,AN,AK,EPSI)
C
        DO 45 IA=1,NUMA
        ANG=FLOAT(IA-1)/FLOAT(NUMA-1)*(POLMX-POLMN)+POLMN
        XMU=COS(ANG*PI180)
C ------------------------------------------------------------------
C       THE SUBROUTINE 'S1S2' CALCULATES THE COMPLEX AMPLITUDES 
C       OF SCATTERING 'CS1' Y 'CS2' WHICH CORRESPONDS TO BOTH
C       POLARIZATION STATES OF THE LIGTH SCATTERING,  FS1=CS1**2
C-------------------------------------------------------------------
        CALL S1S2(XMU,CS1,CS2,TDELTA,FS1,FS2,FF)
C
	WRITE(8,*)ANG,TDELTA,FS1,FS2,FF

C
        IF(LDS) THEN
          A(1,IA)=ANG
          A(2,IA)=FS1
          A(3,IA)=FS2
	  A(4,IA)=FF
	  A(5,IA)=TDELTA
	IF(NSR.EQ.1.OR.MOD(IA,NSR).EQ.1) WRITE(1,*)ANG,CS1,CS2,TDELTA,
	1FS1,FS2,FF

        END IF
C 44     FORMAT(1X,9F13.6)
        IF(.NOT.LDS) WRITE(1,*) ANG,CS1,CS2,TDELTA,FS1,FS2,FF
 45     CONTINUE
C
C   DRAWN THE INTENSITIES 'I1'=/S1**/2 E 'I2'=/S2/**2
C ----------------------------------------------------

        IF(LDS) CALL PLS(A,POLMN,POLMX,NUMA,XLAM,RAD,AN,AK)
C
        END IF
C
C  CALCULATION OF THE SCATTERED FLUX INSIDE A GIVEN SOLID ANGLE
C --------------------------------------------------------
        WRITE(6,11)
 11     FORMAT('?DO YOU WANT TO CALCULATE THE ENERGETIC FLUX  ? (S/N) ',$)
        READ(5,567) ANS
        IF(ANS.EQ.'S') THEN
C
        WRITE(6,12)
 12     FORMAT('  IMPUT THE PARTICLE RADIUS'/
     F  '  ? RADIO ? ',$)
        READ(5,*) RAD
        WRITE(6,19)
 19     FORMAT('  ? LOWER POLAR ANGLE( GRADES) ? ',$)
        READ(5,*) POLMN
        WRITE(6,13)
 13     FORMAT('  ? UPPER POLAR ANGLE (IN GRADES) ? ',$)
        READ(5,*) POLMX
        WRITE(6,14)
 14     FORMAT('  ? ACIMUTAL MINIMUM ANGLE (EN GRADES) ? ',$)
        READ(5,*) ACIMN
        WRITE(6,15)
 15     FORMAT('  ? ACIMUTAL MAXIMUM ANGLE (EN GRADES) ? ',$)
        READ(5,*) ACIMX
C
        CALL ABN(XLAM,RAD,AN,AK,EPSI)
C --------------------------------------------------------------
C       THE SUBROUTINE 'SOLID' CALCULATES THE SCATTERD FLUXE INTEGRATED
C        OVER A GIVEN SOLID ANGLE
C ATTENTION: THIS SUBROUTINE MUST NOT BE USED
C       BECAUSE IT HAS NOT BEEN YET SUFFICIENTLY TESTED
C  
C---------------------------------------------------------------
        CALL SOLID(POLMN,POLMX,ACIMN,ACIMX,XI1,XI2,XI)
C
        WRITE(1,20) RAD,POLMN,POLMX,ACIMN,ACIMX,XI1,XI2,XI
 20     FORMAT(1H1,//'  RADIO = ',F13.6
     F  /'  CALCULA EL FLUJO DIFUNDIDO EN EL ANGULO SOLIDO:',
     F  /'  ANGULO POLAR ENTRE ',F13.6,' Y ',F13.6,' GRADOS',
     F  /'  ANGULO ACIMUTAL ENTRE ',F13.6,' Y ',F13.6,' GRADOS'
     F  ///'    F1= ',F13.6/'    F2= ',F13.6/'    F = ',F13.6/)
C
        END IF
C
        WRITE(6,50)
 50     FORMAT('?DO YOU WANT TO BACK AT A NEW IMPUT SITUATION? (S/N)',$)
        READ(5,567) ANS
        IF(ANS.EQ.'S') GO TO 123
C
        STOP
C
        END

C
C       SUBRUTINA ABN
C
C       CALCULA LAS AMPLITUDES PARCIALES A(N) Y B(N) DE LA TEORIA DE MIE
C
C       ' XLAM ' :  LONGITUD DE ONDA DE LA LUZ
C       ' RAD '  :  RADIO DEL OBSTACULO
C       ' CM '   :  INDICE DE REFRACTION (COMPLEJO)
C       ' EPSI ' :  ERROR TOLERADO
C
        SUBROUTINE ABN(XLAM,RAD,AN,AK,EPSI)
        IMPLICIT COMPLEX (C)
        COMMON/CABN/NN,CXA(10000),CXB(10000),X
        DIMENSION CHD(10000)
        DATA CI/(0.,1.)/
        DATA PI2/6.283185307179586/
        X=PI2*RAD/XLAM
        CM=CMPLX(AN,AK)
        CY=CM*X
        XM=1./X
        CYM=1./CY
        XCOTA=SQRT(CABS((1.-CM*CM)/(1.+CM*CM))/EPSI)
C	TYPE,XCOTA
        NN=0
        NX=X+2
        CHD(1)=-CI*CEXP(CI*X)
        CHD(2)=CHD(1)*(XM-CI)
 2      CONTINUE
        NN=NN+1
        CHD(NN+2)=(2*FLOAT(NN)+1)*XM*CHD(NN+1)-CHD(NN)
        IF(NN.LE.NX) GO TO 2
        IF(ABS(AIMAG(CHD(NN+1))).LT.XCOTA) GO TO 2
        CALL CSUBM(NN,CY,CAB,EPSI,IERR)
        IF(IERR.EQ.1) WRITE(6,*) ' ERROR EN SUBM'
        IF(IERR.EQ.1) STOP
C        TYPE*,'NN',NN
	N=NN
        COM=CM*XM-CYM
 3      CONTINUE
        COM1=N*COM+CAB
        CXA(N)=(COM1*REAL(CHD(N+1))-CM*REAL(CHD(N)))
     F  /(COM1*CHD(N+1)-CM*CHD(N))
        CXB(N)=(CM*CAB*REAL(CHD(N+1))-REAL(CHD(N)))
     F  /(CM*CAB*CHD(N+1)-CHD(N))
        CAB=FLOAT(2*N-1)*CYM-1./CAB
        N=N-1
        IF(N.NE.0) GO TO 3
        RETURN
        END

C
        SUBROUTINE CSUBM(N,CZ,CX,EPSI,IERR)
C       CALCULA CX=J(Z,N-1)/J(Z,N) CON MI METODO (Z COMPLEJO)
        IMPLICIT COMPLEX (C)
C
        IERR=1
        IF(N.LE.0.OR.EPSI.LE.0..OR.REAL(CZ).LE.0.
     F  .OR.AIMAG(CZ).LT.0.) RETURN
        IERR=0
C
        CF0=0.
        CF1=1.
        CS=0.
        CF=FLOAT(2*N-1)/CZ
        CDF=2./CZ
	NSUB=0
 1      CONTINUE
	NSUB=NSUB+1
        CF=CF+CDF
        CF2=CF*CF1-CF0
        CS1=(1./CF1)/CF2
        CS=CS+CS1
        CF0=CF1
        CF1=CF2
C
        IF(ABS(REAL(CS1)).GT.EPSI.OR.ABS(AIMAG(CS1)).GT.EPSI)
     F  GO TO 1
C
C	TYPE*,'NSUB',NSUB
        CX=1./CS
C
        END

C
        SUBROUTINE QSAE(QS,QA,QE,SEALB)
        IMPLICIT COMPLEX (C)
        COMMON/CABN/NN,CXA(10000),CXB(10000),ALFA
        QS=0.
        QE=0.
        DO 5 N=1,NN
        XN2=2*N+1
        QS=QS+XN2*(CABS(CXA(N))**2+CABS(CXB(N))**2)
        QE=QE+XN2*REAL(CXA(N)+CXB(N))
5       CONTINUE
        QS=2.*QS/(ALFA*ALFA)
        QE=2./(ALFA*ALFA)*QE
        QA=QE-QS
        SEALB=QS/QE
        G=4.*G/(ALFA*ALFA*QS)
	RETURN
	END

C

        SUBROUTINE ASIM(QS,G)
C       CALCULA EL FACTOR DE ASIMETRIA <COS THETA>
        IMPLICIT COMPLEX (C)
        COMMON/CABN/NN,CXA(10000),CXB(10000),ALFA
        G=0.
        NN1=NN-1
        DO 5 N=1,NN1
        G=G+(FLOAT(N)*FLOAT(N+2))/FLOAT(N+1)
     F  *REAL(CXA(N)*CONJG(CXA(N+1))+CXB(N)*CONJG(CXB(N+1)))
     F  +(2*FLOAT(N)+1)/(FLOAT(N)*FLOAT(N+1))
	1*REAL(CXA(N)*CONJG(CXB(N)))
5       CONTINUE
        G=4.*G/(ALFA*ALFA*QS)
        RETURN
        END

C

        SUBROUTINE SOLID(T1,T2,F1,F2,XI1,XI2,XI)
C       FLUJO A TRAVES DEL ANGULO SOLIDO ELEGIDO
C       ANGULOS EN GRADOS
C       T1= ANG. POLAR MINIMO (=> 0.)
C       T2= ANG. POLAR MAXIMO (=< 180.) 
C       F1= ANG. ACIMUTAL MIN. (=> 0.)
C       F2= ANG. ACIMUTAL MAX. (=< 360.)
C       XI1 = FLUJO CON /S1/**2 IDEM XI2
C       XI=XI1+XI2
        IMPLICIT COMPLEX (C)
        COMMON/CABN/NN,CXA(10000),CXB(10000),ALFA
        DIMENSION XMD(20),DF1(20),DF2(20)
        DATA PI180/1.7452922E-2/
        F1R=F1*PI180
        F2R=F2*PI180
        XMU1=COS(T1*PI180)
        XMU2=COS(T2*PI180)
        S1=0.25*SIN(2.*F1R)
        S2=0.25*SIN(2.*F2R)
        FAC1=(-S2+0.5*F2R+S1-0.5*F1R)/(ALFA*ALFA)
        FAC2=(S2+0.5*F2R-S1-0.5*F1R)/(ALFA*ALFA)
        CALL STGS20(XMU2,XMU1,XMD)
        DO 1 IMU=1,20
        XMU=XMD(IMU)
        CALL S1S2(XMU,CS1,CS2,TDELTA,FS1,FS2,FF)
        DF1(IMU)=CS1*CONJG(CS1)
        DF2(IMU)=CS2*CONJG(CS2)
 1      CONTINUE
        CALL REGS20(XMU2,XMU1,DF1,RES1)
        CALL REGS20(XMU2,XMU1,DF2,RES2)
        XI1=FAC1*RES1
        XI2=FAC2*RES2
        XI=XI1+XI2
        RETURN
        END

C
        SUBROUTINE S1S2(XMU,CS1,CS2,TDELTA,FS1,FS2,FF)
C       CALCULA LAS AMPLITUDES COMPLEJAS S1 Y S2 
C       XMU= COSENO DEL ANGULO POLAR
C       CS1 = AMPLITUD (COMPLEJA) S1. IDEM CS2
C       TDELTA= DESFASE ENTRE LAS ONDAS S1 Y S2
C       FS1=/S1/** IDEM FS2
        IMPLICIT COMPLEX (C)
        COMMON/CABN/NN,CXA(10000),CXB(10000),ALFA
	QS=0.
	DO 5 N=1,NN
	XN2=2*N+1
	QS=QS+XN2*(CABS(CXA(N))**2+CABS(CXB(N))**2)
5       CONTINUE
         QS=QS*2/(ALFA*ALFA)
        P0=0.
        P1=1.
        CSP=(0.,0.)
        CSM=(0.,0.)
        FI1=1
        FI2=0
        DO 1 N=1,NN
        S=XMU*P1
        T=S-P0
        T1=FLOAT(N)*T-P0
        FI1=FI1+FLOAT(2)
        FI2=FI2+FLOAT(N)
        XN=FI1/FI2
C        XN=FLOAT(I1)/FLOAT(I2)
        CSP=CSP+XN*(CXA(N)+CXB(N))*(P1+T1)
        CSM=CSM+XN*(CXA(N)-CXB(N))*(P1-T1)
        P0=P1
        P1=S+FLOAT(N+1)/FLOAT(N)*T
 1      CONTINUE
        CS1=(CSP+CSM)*0.25
        CS2=(CSP-CSM)*0.25
        TDELTA=(REAL(CS1)*AIMAG(CS2)-REAL(CS2)*AIMAG(CS1))/
     F  (REAL(CS1)*REAL(CS2)+AIMAG(CS1)*AIMAG(CS2))
	FS1=CS1*CONJG(CS1)
	FS2=CS2*CONJG(CS2)
	FF=(FS1+FS2)*2/(ALFA*ALFA*QS)
        RETURN
        END

C

      SUBROUTINE STGS20(XINF,XSUP,Z)
C     INTEGRACION GAUSS CON 20 PUNTOS
C     LLAMADA EN 'SOLID'
C     CALCULA LOS PUNTOS DE INTEGRACION
      DIMENSION X(10),Z(20)
      DATA X/-.9931285991,-.9639719272,-.9122344282,-.8391169718,
     F -.7463319064,-.6360536807,-.5108670019,-.3737060887, 
     F -.2277858511,-.0765265211/  
      DO 10 I=1,10 
      Z(I)=(XSUP-XINF)*X(I)/2.+XSUP/2.+XINF/2. 
      L=21-I 
      Z(L)=(XINF-XSUP)/2.*X(I)+(XSUP+XINF)/2.
   10 CONTINUE
      RETURN 
      END

C

       SUBROUTINE REGS20(XINF,XSUP,F,VI)
C     INTEGRACION GAUSS CON 20 PUNTOS
C     LLAMADA EN 'SOLID'
C     CALCULA LA INTEGRAL
       DIMENSION F(20) 
       DIMENSION A(10) 
       DATA A/.0176140071,.0406014298,.0626720483,.0832767415,  
     F .1019301198,.1181945319,.1316886384,.1420961093,.1491729864,
     F .1527533871/
       SUM=0. 
       DO 10 I=1,10 
       L=21-I 
       SUM=SUM+A(I)*(F(I)+F(L)) 
   10  CONTINUE 
       VI=SUM*(XSUP-XINF)/2.
       RETURN 
       END

C

        SUBROUTINE PLQ(IOP1,IOP2,A,RDMN,RDMX,NUMR,XLAM,AN,AK)
C       DIBUJA LAS Q
        DIMENSION A(6,1000)
        CALL NEWDEV(,'QMIE.VEC',8)
        XMAX=20.
        YMAX=20.
        CALL PLOTST(,'CM',0)
        CALL PLOT(4.,4.,-3)
        DO 1 IH=IOP1,IOP2
        CALL PLOT(0.,0.,3)
        CALL PLOT(0.,YMAX,2)
        CALL PLOT(XMAX,YMAX,2)
        CALL PLOT(XMAX,0.,2)
        CALL PLOT(0.,0.,2)

        CALL SYMBOL(5.,-1.5,0.38,'RADIO(MICRAS)',0.,13)
        CALL SYMBOL(10.,19.,0.38,'LAMBDA=',0.,7)
        CALL NUMBER(13.,19.,0.38,XLAM,0.,2)
        CALL SYMBOL(10.,18.,0.38,'INDICE=',0.,7)
        CALL NUMBER(13.,18.,0.38,AN,0.,2)
        CALL SYMBOL(15.,18.,0.38,' + I ',0.,5)
        CALL NUMBER(17.,18.,0.38,AK,0.,5)

        IF(IH.EQ.1) CALL SYMBOL(-2.,6.,0.50,
     F  'COEFICIENTE DE SCATTERING',90.,25)
        IF(IH.EQ.2) CALL SYMBOL(-2.,6.,0.50,
     F  'COEFICIENTE DE ABSORCION',90.,24)
        IF(IH.EQ.3) CALL SYMBOL(-2.,6.,0.50,
     F  'COEFICIENTE DE EXTINCION',90.,24)
        IF(IH.EQ.4) CALL SYMBOL(-2.,6.,0.50,
     F  'SIMPLE SCATTERING ALBEDO',90.,24)
        IF(IH.EQ.5) CALL SYMBOL(-2.,6.,0.50,
     F  'FACTOR DE ASIMETRIA',90.,19)
	IF(IH.GT.3)THEN
        DY=YMAX/14.
        DO 11 I=0,14
        CALL PLOT(0.,DY*I,3)
        CALL PLOT(0.15,DY*I,2)
        F=-0.2+FLOAT(I)*0.1
        CALL NUMBER(-1.5,DY*I-0.2,0.38,F,0.,1)
 11     CONTINUE
	ELSE
        DY=YMAX/12.
        DO 10 I=0,12
        CALL PLOT(0.,DY*I,3)
        CALL PLOT(0.15,DY*I,2)
        F=FLOAT(I)/2.
        CALL NUMBER(-1.5,DY*I-0.2,0.38,F,0.,1)
 10     CONTINUE
 	END IF
        CALL ROUND(RDMN,RDMX,RR,RST,M1)
 24     CONTINUE
        RR=RR+RST
        IF(RR.GT.RDMX) GO TO 23
        XPAP=XMAX/(RDMX-RDMN)*(RR-RDMN)
        CALL PLOT(XPAP,0.,3)
        CALL PLOT(XPAP,0.15,2)
        CALL NUMBER(XPAP-0.2,-0.7,0.38,RR,0.,M1)
        GO TO 24
 23     CONTINUE
        DO 27 IP=1,NUMR
        XPAP=XMAX/(RDMX-RDMN)*(A(1,IP)-RDMN)
	IF(IH.GT.3)THEN
	YPAP=YMAX/1.4*(A(IH+1,IP)+0.2)
	ELSE
        YPAP=YMAX/6.*A(IH+1,IP)
	END IF
        IF(IP.EQ.1) CALL PLOT(XPAP,YPAP,3)
        CALL PLOT(XPAP,YPAP,2)
 27     CONTINUE
        CALL PLOT(28.,0.,-3)
 1      CONTINUE
        CALL PLOTND
        RETURN
        END

C

        SUBROUTINE PLS(A,POLMN,POLMX,NUMA,XLAM,RAD,AN,AK)
C       DIBUJA LAS /S1/**2 Y /S2/**2
        DIMENSION A(6,1000)
C
        CALL NEWDEV(,'SMIE.VEC',8)
        XMAX=20.
        YMAX=20.
        CALL PLOTST(,'CM',0)
        CALL PLOT(4.,4.,-3)
	DO J=1,2
        CALL PLOT(0.,0.,3)
        CALL PLOT(0.,YMAX,2)
        CALL PLOT(XMAX,YMAX,2)
        CALL PLOT(XMAX,0.,2)
        CALL PLOT(0.,0.,2)
        CALL SYMBOL(5.,-1.5,0.38,'ANGULO (GRADOS)',0.,15)
        CALL SYMBOL(10.,19.,0.38,'LAMBDA=',0.,7)
        CALL NUMBER(13.,19.,0.38,XLAM,0.,4)
        CALL SYMBOL(10.,18.,0.38,'RADIO=',0.,6)
        CALL NUMBER(13.,18.,0.38,RAD,0.,4)
        CALL SYMBOL(10.,17.,0.38,'INDICE=',0.,7)
        CALL NUMBER(13.,17.,0.38,AN,0.,2)
        CALL SYMBOL(15.,17.,0.38,' + I ',0.,5)
        CALL NUMBER(17.,17.,0.38,AK,0.,5)
	IF(J.EQ.1)THEN
        CALL SYMBOL(10.,16.,0.38,'I1 -------',0.,10)
        CALL SYMBOL(10.,15.,0.38,'I2 - - - -',0.,10)
        CALL SYMBOL(-2.,3.,0.50,'AMPLITUDES AL CUADRADO',90.,22)
	ELSE
        CALL SYMBOL(-2.,3.,0.50,'FUNCION DE FASE',90.,15)
	END IF
C
        EXT=0.
        DO 10 IA=1,NUMA
	IF(J.EQ.1)THEN
        EXT=AMAX1(EXT,A(2,IA))
        EXT=AMAX1(EXT,A(3,IA))
	ELSE
	EXT=AMAX1(EXT,A(4,IA))
	END IF
 10     CONTINUE
        EXT=EXT*1.5
        CALL ROUND(0.,EXT,YY,YST,M1)
 34     CONTINUE
        YY=YY+YST
        IF(YY.GT.EXT) GO TO 33
        YPAP=YMAX/EXT*YY
        CALL PLOT(0.,YPAP,3)
        CALL PLOT(0.15,YPAP,2)
        IF(YY.NE.0.) CALL NUMBER(-1.5,YPAP-0.2,0.38,YY,0.,M1)
        IF(YY.EQ.0.) CALL NUMBER(-1.5,YPAP-0.2,0.38,0.,0.,0)
        GO TO 34
 33     CONTINUE
C
        CALL ROUND(POLMN,POLMX,PP,PST,M1)
 24     CONTINUE
        PP=PP+PST
        IF(PP.GT.POLMX) GO TO 23
        XPAP=XMAX/(POLMX-POLMN)*(PP-POLMN)
        CALL PLOT(XPAP,0.,3)
        CALL PLOT(XPAP,0.15,2)
        IF(PP.NE.0.) CALL NUMBER(XPAP-0.2,-0.7,0.38,PP,0.,M1)
        IF(PP.EQ.0.) CALL NUMBER(XPAP-0.2,-0.7,0.38,0.,0.,0)
        GO TO 24
 23     CONTINUE
	IF(J.EQ.1)THEN
        DO 28 IC=1,2
        DO 27 IP=1,NUMA
        XPAP=XMAX/(POLMX-POLMN)*(A(1,IP)-POLMN)
        YPAP=YMAX/EXT*A(IC+1,IP)
        IF(IP.EQ.1) CALL PLOT(XPAP,YPAP,3)
        IF(IC.EQ.1.OR.MOD(IP,2).EQ.0) CALL PLOT(XPAP,YPAP,2)
        IF(IC.EQ.2.AND.MOD(IP,2).EQ.1) CALL PLOT(XPAP,YPAP,3)
 27     CONTINUE
 28     CONTINUE
	CALL PLOT(28.,0.,-3)
	ELSE
	DO 29 IP=1,NUMA
        XPAP=XMAX/(POLMX-POLMN)*(A(1,IP)-POLMN)
        YPAP=YMAX/EXT*A(4,IP)
        IF(IP.EQ.1) CALL PLOT(XPAP,YPAP,3)
	CALL PLOT(XPAP,YPAP,2)
 29     CONTINUE
	END IF
	END DO
        CALL PLOTND
        RETURN
        END


        SUBROUTINE ROUND(XMN,XMX,XX,XST,M1)
        DIMENSION AC(4)
        DATA AC/0.2,0.1,0.05,0.02/
        M=1+AINT(LOG10(XMX-XMN))

        XB=((XMX-XMN)*10.**(-M))/3.
        DO J=1,4
	END DO
	DO 21 I=1,4
        IF(AC(I).LE.XB) GO TO 22
 21     CONTINUE
 22     XST=AC(I)*10.**M
        XX=AINT(XMN/XST)*XST
        IF(XX.EQ.XMN) XX=XMN-XST
        M1=2-M
        RETURN
        END



  
